MODULE fioTest;

IMPORT
  (* $IF Debug *) Debug, (* $END *)
  NoGuru, io, fio, FSystem;

VAR
  file : fio.File;
  i : LONGINT;
  str : ARRAY 256 OF CHAR;

BEGIN
  LOOP
    io.WriteString("Opening file 'fiotest.dat': ");
    IF ~fio.open(file, "fiotest.dat", fio.newFile) THEN
      io.WriteString("failure ");
      io.WriteInt(file.status, 1); io.WriteLn;
      EXIT;
    END;
    io.WriteString("ok\n");

    io.WriteString("Writing integer 42: ");
    IF ~fio.WriteInt(file, 42, 1) THEN
      io.WriteInt(file.status, 1); io.WriteLn;
      fio.close(file);
      EXIT;
    END;
    io.WriteString("ok\n");

    io.WriteString("Writing string 'Hallo Nase!': ");
    IF ~fio.WriteString(file, "Hallo Nase!\n") THEN
      io.WriteInt(file.status, 1); io.WriteLn;
      fio.close(file);
      EXIT;
    END;
    io.WriteString("ok\n");

    io.WriteString("Seeking back: ");
    IF ~FSystem.Move(file, 0) THEN
      io.WriteInt(file.status, 1); io.WriteLn;
      fio.close(file);
      EXIT;
    END;
    io.WriteString("ok\n");

    io.WriteString("Reading integer: ");
    IF ~fio.ReadLong(file, i) THEN
      io.WriteString("failure ");
      io.WriteInt(file.status, 1); io.WriteLn;
      fio.close(file);
      EXIT;
    END;
    io.WriteString("ok ");
    io.WriteInt(i,1);
    io.WriteLn;

    io.WriteString("Reading string: ");
    IF ~fio.ReadString(file, str) THEN
      io.WriteString("failure ");
      io.WriteInt(file.status, 1); io.WriteLn;
      fio.close(file);
      EXIT;
    END;
    io.WriteString("ok '");
    io.WriteString(str);
    io.WriteString("'\n");

    io.WriteString("Reading integer (should fail): ");
    IF ~fio.ReadLong(file, i) THEN
      io.WriteString("failure ");
      io.WriteInt(file.status, 1); io.WriteLn;
    ELSE
      io.WriteString("ok ");
      io.WriteInt(i,1);
      io.WriteLn;
    END;

    io.WriteString("Closing file.\n");
    fio.close(file);
    EXIT;
  END;
  io.WriteString("--- Done ---\n");
END fioTest.
