#ifndef LIBRARIES_PATTERN_H
#define LIBRARIES_PATTERN_H

/*
**
**	$Filename: libraries/pattern.h $
**	$Version: 5.00 $
**	$Date: 92/01/28 $
**
**	pattern.library definitions and prototypes
**
**	(C) Copyright 1992 by Angela Schmidt, Neu-Ulm 8, Germany
**	    All Rights Reserved
**
*/

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif


#define Prototype extern	/* DICE likes this */


/*****************\
*** Definitions ***
\*****************/

#define PATLIB_MIN_VERSION 5L		/* Version of the 1st library released	*/
#define PATLIB_ACT_VERSION 5L		/* Version of the actual library	*/
					/* Please use PATLIB_MIN_VERSION	*/
					/* in your sources whenever possible.	*/
#define PATLIB_REVISION 0L		/* Revision of the libray.		*/
#define PATLIB_NAME "pattern.library"	/* Name of this famous library		*/


/****************\
*** Prototypes ***
\****************/

Prototype void Surprise (struct Window *, LONG);
Prototype STRPTR Str2Upper (STRPTR);
Prototype STRPTR Str2Lower (STRPTR);
Prototype UBYTE Char2Upper (UBYTE);
Prototype UBYTE Char2Lower (UBYTE);
Prototype LONG GetAllocCounter (void);
Prototype LONG AllocPattern (STRPTR, ULONG);
Prototype LONG AllocPatternNoCase (STRPTR, ULONG);
Prototype LONG IsPattern (STRPTR, STRPTR, ULONG);
Prototype STRPTR ESCPattern (STRPTR, STRPTR, ULONG);
Prototype LONG MatchThePattern (LONG, STRPTR);
Prototype void FreePattern (LONG);
Prototype LONG SimpleMatch (STRPTR, STRPTR);
Prototype LONG SimpleMatchNoCase (STRPTR, STRPTR);
Prototype STRPTR PatternErrorString (LONG, STRPTR, STRPTR, ULONG);
Prototype LONG PatternError2DOS (LONG);
Prototype LONG XParsePattern (STRPTR, STRPTR, LONG);
Prototype LONG XParsePatternNoCase (STRPTR, STRPTR, LONG);
Prototype BOOL XMatchPattern (STRPTR, STRPTR);
Prototype BOOL XMatchPatternNoCase (STRPTR, STRPTR);

#endif /* LIBRARIES_PATTERN_H */
